#!/bin/bash

# This is a tempfile(1) replacement. Only supported argument is "-s" yet
# (for temp filename suffix). Config will use this script on a system where
# neither tempfile nor mktemp is supported.
#
# ***************************** WARNING ***********************************
# * This script is not as safe as tempfile(1). Between checking the file  *
# * access and creating the file, an attacker could create a symlink.     *
# * Other vulnerability is the weak randomness of the file names.         *
# *************************************************************************

if test "$1" = "-s"
then
	suffix=$2
else
	suffix=""
fi

prefix="/tmp/cfgtmp"

# We have 8 tries
for n in 1 2 3 4 5 6 7 8
do
	name=${prefix}${RANDOM}${RANDOM}${suffix}
	if ! test -e $name
	then
		echo > $name
		echo $name
		exit
	fi
done

echo "lib/tempfile_unsafe.sh failed to generate an unique temp file name"
false
echo /dev/null
