/*
    libgpmi - General Package/Module Interface
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * @file debug.h
 *  \brief Helps out to show debug-information to the end-user.
 *
 *  Use gpmi_debug(level, <your text here>) to say something to the user.
 *  Level 0 means _VERY_ important, where level 9 is far less important.
 */
#ifndef GPMI_DEBUG_H
#define GPMI_DEBUG_H

#include <gpmi/global.h>

extern void (*gpmi_debug_proc)(int level, char *s);

#define gpmi_debug(level, x...)	{          \
		char gpmi_debug_buff[1024];            \
		snprintf(gpmi_debug_buff, 1024, x);      \
		if (gpmi_debug_proc != NULL) \
			gpmi_debug_proc(level, gpmi_debug_buff); \
		else \
			printf("gpmi debug: %d %s\n", level, gpmi_debug_buff); \
	}
//!< Call this macro to show debug-information to the user

#endif /* GPMI_DEBUG_H */
