#!/bin/bash

# We define these empty funcitons here so if the user doesn't redefine them,
# these will be called: error is catched.

function RunTick() {
	true
}

function RunData() {
	true
}

# GPMI wrappers
function GPMI()
{
	local gpmi_tmp

	echo "###GPMI### $*"
	while(/bin/true)
	do
		cli_dprint "[src] (parsing1) $result"	
		gpmi_parse "GPMI $*" 
		if test "$?" != "0"
		then 
			cli_dprint "[crc] (return) $result"
			true
			return
		fi
		cli_dprint "[src] (parsing2) $result"
	done
}

function cli_dprint()
{
	echo "###GPMI### cli_dprint $*"
}

function cli_print()
{
	echo "###GPMI### cli_print $*"
}


function gpmi_parse() {
	cli_dprint "[src] waiting for $*"
	read gpmi_tmp
	cli_dprint "[src] IN: $gpmi_tmp"

	gpmi_arg=${gpmi_tmp#*[ 	]}
	gpmi_cmd=${gpmi_tmp%%[ 	]*}

	if test -z "$gpmi_cmd"
	then
		false
		return
	fi

	true
	case "$gpmi_cmd" in
		Event)	$gpmi_arg ; echo "###GPMI_FIN### Event" ; return ;;
		RunTick) RunTick $gpmi_arg ; echo "###GPMI_FIN### RunTick" ; return ;;
		RunData) RunData $gpmi_arg ; echo "###GPMI_FIN### RunData" ; return ;;
		Rehash) exec $gpmi_arg ;;
		Quit) echo "###GPMI_FIN### Quit"; exit ;;
		Nop) ;;
		Result*) result=`echo $gpmi_tmp | sed "s/Result[ ]*//"`; echo "###GPMI_FIN### Result $result"; false; return ;;
		Fin) cli_dprint "[scr] FIN."; return ;;
		*) cli_dprint "Error: unknown input from GPMI: \"$gpmi_tmp\""
	esac
	echo "###GPMI_FIN### (parse) $gpmi_cmd"
}
