/*
    libgpmi - General Package/Module Interface - cli module
    Copyright (C) 2006-2007 Tibor 'Igor2' Palinkas & glx
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define nowrap
#include "packages/bgproc.h"
#include "packages/filter.h"
typedef enum cli_state_e {
	cli_st_idle,
	cli_st_waitfin,
} cli_state_t;

typedef struct cli_t {
	pipe_t fds_a[2];
	pipe_t fds_b[2];
	char *fn;
	filter_t *flt_read;
	filter_t *flt_write;
	cli_state_t state;
} cli_t;

int cli_read_conf(const char *dir, const char *language, char **before, char **after);
int cli_read_confs(const char *mod_path, const char *language, char **dir, char **before, char **after);
int cli_read_confs_multi(int gpmi_path, const char *language, char **dir, char **before, char **after);
cli_t *cli_fork(const char *dir, const char *before, const char *script, const char *after);
int cli_parse(cli_t *c, int timeout, char *cookie);
void cli_send_string(cli_t *c, const char *s);


