/*
    libgpmi - General Package/Module Interface - bgproc package
    Copyright (C) 2006-2007 Tibor 'Igor2' Palinkas & glx 

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef os_dep_h_included
#define os_dep_h_included


#ifdef WIN32
	#include <windows.h>
	typedef HANDLE pipe_t;

	// global var to kill child process on exit
	HANDLE _hProcess;
#else
	typedef int pipe_t;
#endif

typedef enum PipeType {
	BGPROC_PIPE_READ  = 0,
	BGPROC_PIPE_WRITE = 1,
} PipeType;

int bgproc_create_pipe(pipe_t p[2], PipeType t);
void bgproc_close_pipe(pipe_t p[2], PipeType t);
int bgproc_create_child(char* commandline, pipe_t pa[2], pipe_t pb[2]);
int bgproc_write_to_pipe(pipe_t p, const char *buf, int buf_len);
int bgproc_read_from_pipe(pipe_t p, char *buf, int buf_len);

#endif /* os_dep_h_included */
