/*
    libgpmi - General Package/Module Interface - filter package
    Copyright (C) 2005-2007 Tibor 'Igor2' Palinkas

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef filter_h_included
#define filter_h_included

#include <gpmi.h>

typedef struct filter_t {
	char *data;
	int la;												//allocated length
	int l;												//data length
	char *sep;										//separators
	int next;											//next data
	int last;											//last checked byte
	int skip;											//alloc extra bytes every time when data grows
	int flags;
	int step;											//return n bytes at once IF NO SEP DEFINED
} filter_t;

#define flt_oversep	1

char *flt_ws;

void flt_change_sep(filter_t *f, char *newsep);
void flt_step(filter_t *f, int step);
int flt_fill(filter_t *f, char *dt, int len, char **res);
filter_t *flt_init(char *sep, int skip, int flags);
int flt_peek_skip(filter_t *f, char **res);
void flt_close(filter_t *f);

#endif /* filter_h_included */
